'use strict';

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

const _require = require('xml-js'),
      xml2js = _require.xml2js;

class FanfouError extends Error {
  constructor(httpResponse) {
    super();

    var _httpResponse$headers = httpResponse.headers['content-type'].split(';');

    var _httpResponse$headers2 = _slicedToArray(_httpResponse$headers, 1);

    this.contentType = _httpResponse$headers2[0];
    this.httpResponse = httpResponse;
    this.statusCode = httpResponse.statusCode;

    this._parseError();
  }

  _parseError() {
    switch (this.contentType) {
      case 'application/json':
        this.message = JSON.parse(this.httpResponse.body).error;
        break;

      case 'application/xml':
        this.message = xml2js(this.httpResponse.body, {
          compact: true
        }).hash.error._text;
        break;

      case 'text/html':
        {
          const titleMatch = this.httpResponse.body.match(/<title>(.+)<\/title>/);

          if (titleMatch) {
            var _titleMatch = _slicedToArray(titleMatch, 2);

            this.message = _titleMatch[1];
          } else {
            this.message = `http status code ${this.httpResponse.statusCode}`;
          }

          break;
        }

      default:
        break;
    }
  }

}

module.exports = FanfouError;